/*
  graphic.c

  General-use graphic routine (initialize and clear frame buffer) and external variable definitions
  <<< OtBbNėp[`iƃt[obt@NA)ƊOϐ` >>>

  Notice: <<<...>>> is same comment in Japanese (SHIFT JIS code).
*/

#include <nusys.h>
#include "graphic.h"

Gfx          gfx_glist[2][GFX_GLIST_LEN];
Gfx          gfx_clear_glist[2][GFX_CLEAR_GLIST_LEN];
Dynamic      gfx_dynamic[2];
Gfx*         glistp;
u32          gfx_gtask_no = 0;

/*----------------------------------------------------------------------------
  gfxRCPIinit

  Initialize RSP/RDP
----------------------------------------------------------------------------*/
void gfxRCPInit(void)
{
  /* RSP segment register settings */
  /* <<< RSPZOgWX^̐ݒ >>> */
 
  /* For CPU virtual address */
  /* <<< CPUzAhXp >>> */
  gSPSegment(glistp++, 0, 0x0);

  /* RSP setting */
  /* <<< RSP̐ݒ >>> */
  gSPDisplayList(glistp++, OS_K0_TO_PHYSICAL(setup_rspstate));

  /* RDP setting */
  /* <<< RDP̐ݒ >>> */
  gSPDisplayList(glistp++, OS_K0_TO_PHYSICAL(setup_rdpstate));
}

/*----------------------------------------------------------------------------
  gfxClearCfb

  Set address and clear frame buffer/Z buffer
  <<< t[obt@^yobt@̃AhXݒƃNA >>>

  Use the NuSYSTEM global variables nuGfxZBuffer (Z buffer address) and nuGfxCfb_ptr (frame buffer address)
  <<< NuSYSTEM̃O[oϐł nuGfxZBufferiyobt@̃AhXj
      nuGfxCfb_ptrit[obt@̃AhXjgpĂ܂B >>>
----------------------------------------------------------------------------*/
void gfxClearCfb(void)
{
  /* Clear Z buffer */
  /* <<< yobt@̃NA >>> */
  gDPSetDepthImage(glistp++, OS_K0_TO_PHYSICAL(nuGfxZBuffer));
  gDPSetCycleType(glistp++, G_CYC_FILL);
  gDPSetColorImage(glistp++, G_IM_FMT_RGBA, G_IM_SIZ_16b,SCREEN_WD,
		   OS_K0_TO_PHYSICAL(nuGfxZBuffer));
  gDPSetFillColor(glistp++,(GPACK_ZDZ(G_MAXFBZ,0) << 16 |
			       GPACK_ZDZ(G_MAXFBZ,0)));
  gDPFillRectangle(glistp++, 0, 0, SCREEN_WD-1, SCREEN_HT-1);
  gDPPipeSync(glistp++);
  
  /* Clear frame buffer */
  /* <<< t[obt@̃NA >>> */
  gDPSetColorImage(glistp++, G_IM_FMT_RGBA, G_IM_SIZ_16b, SCREEN_WD,
		   osVirtualToPhysical(nuGfxCfb_ptr));
  gDPSetFillColor(glistp++, (GPACK_RGBA5551(0, 0, 0, 1) << 16 | 
				GPACK_RGBA5551(0, 0, 0, 1)));
  gDPFillRectangle(glistp++, 0, 0, SCREEN_WD-1, SCREEN_HT-1);
  gDPPipeSync(glistp++);
}

