/*
   main.c

   NuSYSTEM sample nu2

  Notice: <<<...>>> is same comment in Japanese (SHIFT JIS code).

 */

#include <nusys.h>
#include "main.h"

/* Stage number */
/* <<< Xe[Wԍ >>> */
volatile int stage;

/* Declare prototypes */
/* <<< vg^Cv錾 >>> */
void stage00(int);
void stage01(int);

/* Declare external functions */
/* <<< O֐錾 >>> */
void initStage00(void);
void makeDL00(void);
void updateGame00(void);

void initStage01(void);
void makeDL01(void);
void updateGame01(void);

/* Read Controller 1 data */
/* <<< PRg[ǎf[^ >>> */
NUContData	contdata[1];

/*------------------------
	Main
	<<< C >>>
--------------------------*/
void mainproc(void)
{
  /* Initialize graphic */
  /* <<< OtBbN̏ >>> */
  nuGfxInit();

  /* Initialize controller manager */
  /* <<< Rg[}l[W̏ >>> */
  nuContInit();
	
  /* Set Stage number to 0*/
  /* <<< Xe[WԍOɃZbgB>>> */
  stage = 0;

  while(1)
    {
      switch(stage)
	{
	  /* 
	     Register callback function corresponding to stage number.
	     On the callback function side,
	     set value in stage if a change in registration is
	     required in another callback function.
	     */
	  /* <<<
	     Xe[WԍɂAΉR[obN֐o^܂B
	     R[obN֐ł́A
	     ̃R[obN֐ɓo^ύXKvɂȂɁA
	     stage ɒlZbg܂B
	     >>> */
	case 0:
	  /* Set a value of -1 in stage in order to wait
	     for the value to be set in the callback function. */
	  /* <<< R[obN֐lZbĝ҂߂ɁA
	     stage ̒l-1ɃZbgĂ܂ >>>*/
	  stage = -1;
	  /* Initialize Stage 0 */
	  /* <<< Xe[WȌ >>> */
	  initStage00();
	  /* Register callback */
	  /* <<< R[obNo^ >>> */
	  nuGfxFuncSet((NUGfxFunc)stage00);
	  /* Start display */
	  /* <<< \Jn >>> */
	  nuGfxDisplayOn();
	  break;
	case 1:
	  stage = -1;
	  initStage01();
	  nuGfxFuncSet((NUGfxFunc)stage01);
	  nuGfxDisplayOn();
	  break;
	default:
	  break;
	}
      
      /* Callback function waits for value to change (scene to change) */
      /* <<< R[obN֐l؂ւ́iʐ؂ւj҂ >>> */
      while(stage == -1)
	;
      /* Turn off display */
      /* <<< \ >>> */
      nuGfxDisplayOff();
    }
}


/*-----------------------------------------------------------------------------
  Callback function
  <<< R[obN֐ >>>

  The value of pendingGfx, which is passed from Nusystem as an argument of the 
  callback function, is the sum of the currently processing and waiting to 
  process status of the RCP.
  <<< Nusystem R[obN֐̈Ƃēn pendingGfx  
   ݏя҂ RCP^XN̍vłB >>>
-----------------------------------------------------------------------------*/

/* Stage 0 */
/* <<< Xe[WO >>> */
void stage00(int pendingGfx)
{
  /* <<< ^҂RCP^XNQȉꍇA\s >>> */
  if(pendingGfx < 3)
    makeDL00();		

  /* <<< Q[is >>> */
  updateGame00(); 
}

/* <<< Xe[WP >>> */
void stage01(int pendingGfx)
{
  /* If the processing/waiting to process status of the RCP is 2 or less, perform display process */
  /* <<< ^҂RCP^XNQȉꍇA\s >>> */
  if(pendingGfx < 3)
    makeDL01();

  /* Advance game process */
  /* <<< Q[is >>> */
  updateGame01();
}
